/*****************************************************************************
*                                                                            *
*   Home Finance Database System.                                            *
*   Keep track of your money and have easy access to finding data.           *
*                                                                            *
*   Originally developed on Linux                                            *
*                                                                            *
*   Author: Peter Leif Rasmussen, 1996                                       *
*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include"finance.h"

FILE *log_fp;

extern int main_menu(void);
extern void print_menu(void);
extern int exit_check(void);
extern void new_data(opt_unit *);
extern void view_data(opt_unit *);
extern void load_data(opt_unit *);
extern void save_data(opt_unit *);
extern void edit_data(opt_unit *);
extern void options(opt_unit *);
extern void time_check(struct tm *tid);
void read_options(char *, opt_unit *);

int changed=0;

void main(int argc, char *argv[])
{
opt_unit main_opt;
int menu_choice;

if(argc>1) strcpy(main_opt.options_file,argv[1]);
else strcpy(main_opt.options_file,".options");

if(!(main_opt.items_list=(char **)malloc(100)))
   {printf("main_opt.items_list malloc error\n");exit(-1);}

read_options(main_opt.options_file,&main_opt);

menu_choice=main_menu();

while(menu_choice<8)
	{
	switch (menu_choice)
		{
		case 1:
			new_data(&main_opt);
			break;
		case 2:
			load_data(&main_opt);
			break;
		case 3:
			save_data(&main_opt);
			break;
		case 4:
			view_data(&main_opt);
			break;
		case 5:
			edit_data(&main_opt);
			break;
		case 6:
			options(&main_opt);
			break;
		case 7:
			if(!(exit_check()))
			  {
			  printf("Bye for now :-)\n");
			  exit(0);
			  }
			else break;
		default: 
			break;
		}
	menu_choice=main_menu();
	}
}

void read_options(char *option, opt_unit *items)
{
FILE *optfp, *itemfp;
int n;
char dummy[100];

if(!(optfp=fopen(option,"r")))
   {fprintf(stderr,"Couldn't open \"%s\"\n",option); exit(-1);}

fscanf(optfp,"%s%d",dummy,&(items->items));

fscanf(optfp,"%s%s",dummy,items->items_file);

fscanf(optfp,"%s%s",dummy,items->db_file);

if(!(itemfp=fopen(items->items_file,"r")))
   {fprintf(stderr,"Couldn't open \"%s\"\n",items->items_file); exit(-1);}

for(n=0;n<items->items;n++)
   {
   if(!(items->items_list[n]=(char *)malloc(100)))
        {printf("malloc error\n");exit(-1);}
   fgets(items->items_list[n],100,itemfp);
   }

fclose(optfp);fclose(itemfp);
}
